%
% Bestimmen der Ordnung einer 2x2 Matrix g
% ber Z/29.
%

function[r]=detord(ag,bg,cg,dg)

D=mod(ag*dg-bg*cg,29);

if D==0
    disp('Die Eingabe ist keine invertierbare Matrix.');
    return;
end

A=[ag bg;cg dg];
E=[1 0;0 1];

stop=0;
r=1;
P=E;

while stop==0
    P=mod(P*A,29);
    if isequal(P,E)==true
        stop=1;
    else
        r=r+1;
    end
end % while

disp(['Die Ordnung ist: ' num2str(r)]);

return;